package tareas.tarea1;

/**
 * Esta clase ejecuta el Test que verifica cada punto pedido por el profesor.
 * @author Janther
 */

public final class Test {

    /** Constructor por omisin de la clase.
     */
    private Test() {
    }

    /**
     * Este es el main que ejectuta los metodos de TestFigura.
     * @param args Argumentos para el main: -r revisa mtodos
     * de clonacin y equals de la clase Rectngulo. -c revisa
     * mtodos de clonacin y equals de la clase Circulo. -rc o
     * -cr revisa metodos de clonacin y equals de ambas clases.
     */
    public static void main(String[] args) {
        for (int i = 0; i < args.length; i++) {
            if (args[i].startsWith("-")) {
                if (args[i].contains("c")) {
                    testCirculo();
                }
                if (args[i].contains("r")) {
                    testRectangulo();
                }
            }
        }

        Forma figura;
        TestFigura test = new TestFigura();
        figura = test.figuraFactory();
        test.manipularForma(figura);
    }

    /**
     * Este mtodo se preocupa de testear el clon y equals de la clase
     * Rectngulo.
     */
    private static void testRectangulo() {
        Rectangulo r = new Rectangulo();
        Rectangulo r1 = (Rectangulo) r.clone();
        /*
         * Hasta ahora el equals no nos dice nada ya que esta recien clonado.
         */
        if (r.equals(r1)) {
            System.out.println("Bien, hasta ahora.");
        } else {
            System.out.println("Mal, no clono bien.");
        }

        r.trasladar(1, 1);
        /*
         * Ahora no debieran ser iguales ya que trasladamos solo 1.
         */
        if (r.equals(r1)) {
            System.out.println("Mal, no clono, solo copio.");
        } else {
            System.out.println("Bien, clono perfectamente el Rectangulo.");
        }

        r1.trasladar(1, 1);
        /*
         * Ahora comprobaremos que el equal funciona ya que se posicionaron
         * ambos en el mismo lugar.
         */
        if (r.equals(r1)) {
            System.out.println("Bien, el equals detecta bien el Rectangulo.");
        } else {
            System.out.println("Mal el Equals no detecta bien.");
        }
    }

    /**
     * Este mtodo se preocupa de testear el clon y equals de la clase Circulo.
     */
    private static void testCirculo() {
        Circulo c = new Circulo();
        Circulo c1 = (Circulo) c.clone();
        /*
         * Hasta ahora el equals no nos dice nada ya que esta recien clonado.
         */
        if (c.equals(c1)) {
            System.out.println("Bien, hasta ahora.");
        } else {
            System.out.println("Mal, no clono bien.");
        }

        c.trasladar(-1, -1);
        /*
         * Ahora no debieran ser iguales ya que trasladamos solo 1.
         */
        if (c.equals(c1)) {
            System.out.println("Mal, no clono, solo copio.");
        } else {
            System.out.println("Bien, clono perfectamente el Circulo.");
        }

        c1.trasladar(-1, -1);
        /*
         * Ahora comprobaremos que el equal funciona ya que se posicionaron
         * ambos en el mismo lugar.
         */
        if (c.equals(c1)) {
            System.out.println("Bien, el equals detecta bien el Circulo.");
        } else {
            System.out.println("Mal el Equals no detecta bien.");
        }
    }
}
