package tareas.tarea2;

import javax.swing.JFrame;
import tareas.tarea2.gui.Barra;
import tareas.tarea2.gui.Dibujo;

/**
 * Clase que implementa la interfaz grfica del programa.
 * @author Janther
 */
public final class Simulador extends JFrame {

    /**
     * Numero Serial de la clase.
     */
    private static final long serialVersionUID = 1;
    /**
     * Constructor por omisin de la clase.
     * @param applet Booleano que informa al constructor si este se est
     * corriendo de un applet o de un ejecutable.
     */
    public Simulador(final boolean applet) {
        setTitle("Simulador de Redes Elctricas.");
        if (!applet) {
            JFrame.setDefaultLookAndFeelDecorated(true);
            setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        }
        Dibujo panel = new Dibujo();
        setContentPane(panel);
        setJMenuBar(new Barra(panel));

        pack();
        final int anchoInicial = 640;
        final int altoInicial = 480;
        setSize(anchoInicial, altoInicial);
        setResizable(true);
    }

    /**
     * Constructor de la clase.
     * @param args Argumento entregado al ejecutar, debe ser null.
     */
    public static void main(final String[] args) {
        JFrame ventana = new Simulador(false);
        ventana.setVisible(true);
    }
}
