package tareas.tarea2.electronica;

import java.awt.Graphics2D;
import java.awt.Point;
import java.util.ArrayList;
import tareas.tarea1.Figura;

/**
 * Clase hija de Figura que agrega los metodos necesarios para manejar los
 * los Componentes de un circuito.
 * @author Klaus
 */
public class Circuito extends Figura {

    /** Rota la forma respecto a su centro en 90 grados.
     */
    public void rotar() {
        /*
         * Por cada Componente en Circuito se ejecuta el metodo rotar().
         */
        for (int i = 0; i < formas.size(); i++) {
            if (formas.get(i) instanceof Componente) {
                ((Componente) formas.get(i)).rotar();
            }
        }
    }

    /** Metodo que pinta todas las formas en el panel.
     * @param g objeto grafico que nos permite dibujar.
     */
    public void paintComponent(Graphics2D g) {
        for (int i = 0; i < formas.size(); i++) {
            if (formas.get(i) instanceof Componente) {
            ((Componente) formas.get(i)).paintComponent(g);
            }
        }
    }

    /**
     * Verifica si alguna de las formas fue de la figura fue seleccionada.
     * @param p Punto a verificar.
     * @return El ID de la forma seleccionada.
     */
    public int selectedForma(Point p) {
        for (int i = 0; i < formas.size(); i++) {
            if (formas.get(i) instanceof Componente) {
                if (((Componente) formas.get(i)).isSelected(p)) {
                    return i;
                }
            }
        }
        return -1;
    }

    /**
     * Retorna un arreglo de los nodos de los Componentes todos los componentes
     * del circuito con excepcion al que tiene ID i.
     * @param i ID del componente cuyos nodos no se requieren.
     * @return arreglo de los nodos de los componentes.
     */
    public ArrayList < Nodo > getNodos(int i) {
        ArrayList < Nodo > nodos = new ArrayList < Nodo >();
        for (int j = 0; j < formas.size(); j++) {
            if (i != j) {
                if (formas.get(j) instanceof Componente) {
                    Nodo[] n = ((Componente) formas.get(j)).getNodos();
                        for (int k = 0; k < n.length; k++) {
                            nodos.add(n[k]);
                    }
                }
            }
        }
        return nodos;
    }
}
